'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2, _initialiseProps;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Repeatable = (_temp2 = _class = function (_PureComponent) {
    _inherits(Repeatable, _PureComponent);

    function Repeatable() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Repeatable);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Repeatable.__proto__ || Object.getPrototypeOf(Repeatable)).call.apply(_ref, [this].concat(args))), _this), _initialiseProps.call(_this), _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Repeatable, [{
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.releaseTimer();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var children = this.props.children;


            var items = _react2.default.Children.map(children, function (child) {
                if (!_react2.default.isValidElement(child)) {
                    return child;
                }

                var release = function release(event) {
                    _this2.releaseTimer();

                    setTimeout(function () {
                        if (typeof _this2.props.onRelease === 'function') {
                            _this2.props.onRelease(event);
                        }
                    }, 0);
                };
                var press = function (callback) {
                    return function (event) {
                        event.persist();

                        var releaseOnce = function releaseOnce(event) {
                            document.documentElement.removeEventListener('mouseup', releaseOnce);
                            release(event);
                        };
                        document.documentElement.addEventListener('mouseup', releaseOnce);

                        if (typeof _this2.props.onPress === 'function') {
                            _this2.props.onPress(event);
                        }

                        _this2.acquireTimer(callback, event);
                    };
                }(child.props.onClick);

                return (0, _react.cloneElement)(child, {
                    onMouseDown: press,
                    onMouseUp: release,
                    onTouchStart: press,
                    onTouchCancel: release,
                    onTouchEnd: release
                });
            });

            return _react2.default.createElement(
                'div',
                null,
                items
            );
        }
    }]);

    return Repeatable;
}(_react.PureComponent), _class.propTypes = {
    // The time (in milliseconds) to wait before the action is being triggered.
    enterDelay: _propTypes2.default.number,

    // The intervals (in milliseconds) on how often to trigger the action.
    intervalDelay: _propTypes2.default.number,

    // Callback fired when the mousedown or touchstart event is triggered.
    onPress: _propTypes2.default.func,

    // Callback fired when the mouseup, touchcancel, or touchend event is triggered.
    onRelease: _propTypes2.default.func
}, _initialiseProps = function _initialiseProps() {
    var _this3 = this;

    this.enterTimer = null;
    this.intervalTimer = null;

    this.acquireTimer = function (callback) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
            args[_key2 - 1] = arguments[_key2];
        }

        var enterDelay = Number(_this3.props.enterDelay) || 500;
        var intervalDelay = Number(_this3.props.intervalDelay) || 50;

        _this3.releaseTimer();

        _this3.enterTimer = setTimeout(function () {
            _this3.intervalTimer = setInterval(function () {
                if (_this3.intervalTimer && typeof callback === 'function') {
                    callback.apply(undefined, args);
                }
            }, intervalDelay);
        }, enterDelay);
    };

    this.releaseTimer = function () {
        if (_this3.enterTimer) {
            clearTimeout(_this3.enterTimer);
            _this3.enterTimer = null;
        }
        if (_this3.intervalTimer) {
            clearInterval(_this3.intervalTimer);
            _this3.intervalTimer = null;
        }
    };
}, _temp2);
exports.default = Repeatable;